'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _reduxQueueOfflineListener = require('redux-queue-offline-listener');

var _reduxQueueOfflineListener2 = _interopRequireDefault(_reduxQueueOfflineListener);

var _reduxOptimist = require('redux-optimist');

var _reduxOptimist2 = _interopRequireDefault(_reduxOptimist);

var _reduxOptimistPromise = require('redux-optimist-promise');

var _reduxOptimistPromise2 = _interopRequireDefault(_reduxOptimistPromise);

var _reduxToastFeedback = require('redux-toast-feedback');

var _reduxStorage = require('redux-storage');

var storage = _interopRequireWildcard(_reduxStorage);

var _reduxStorageEngineLocalstorageMap = require('redux-storage-engine-localstorage-map');

var _reduxStorageEngineLocalstorageMap2 = _interopRequireDefault(_reduxStorageEngineLocalstorageMap);

var _reduxStorageDecoratorDebounce = require('redux-storage-decorator-debounce');

var _reduxStorageDecoratorDebounce2 = _interopRequireDefault(_reduxStorageDecoratorDebounce);

var _reduxStorageDecoratorMigrate = require('redux-storage-decorator-migrate');

var _reduxStorageDecoratorMigrate2 = _interopRequireDefault(_reduxStorageDecoratorMigrate);

var _reduxQueueOffline = require('redux-queue-offline');

var _createHashHistory = require('history/lib/createHashHistory');

var _createHashHistory2 = _interopRequireDefault(_createHashHistory);

var _reactRouter = require('react-router');

var _scrollBehavior = require('scroll-behavior');

var _scrollBehavior2 = _interopRequireDefault(_scrollBehavior);

var _reactRouterRedux = require('react-router-redux');

var _reduxObjectToPromise = require('redux-object-to-promise');

var _reduxObjectToPromise2 = _interopRequireDefault(_reduxObjectToPromise);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var noop = function noop() {};

module.exports = function initStore(_ref) {
  var _ref$sendAppView = _ref.sendAppView;
  var sendAppView = _ref$sendAppView === undefined ? noop : _ref$sendAppView;
  var storageMap = _ref.storageMap;
  var _ref$storageDebounce = _ref.storageDebounce;
  var storageDebounce = _ref$storageDebounce === undefined ? 1000 : _ref$storageDebounce;
  var _ref$storageVersion = _ref.storageVersion;
  var storageVersion = _ref$storageVersion === undefined ? 0 : _ref$storageVersion;
  var _ref$storageMigration = _ref.storageMigrations;
  var storageMigrations = _ref$storageMigration === undefined ? [] : _ref$storageMigration;
  var _ref$blacklistedActio = _ref.blacklistedActions;
  var blacklistedActions = _ref$blacklistedActio === undefined ? [_reactRouterRedux.CALL_HISTORY_METHOD, _reactRouterRedux.LOCATION_CHANGE] : _ref$blacklistedActio;
  var _ref$loggerOptions = _ref.loggerOptions;
  var loggerOptions = _ref$loggerOptions === undefined ? {
    collapsed: true,
    duration: true,
    timestamp: false
  } : _ref$loggerOptions;
  var _ref$objectToPromiseO = _ref.objectToPromiseOptions;
  var objectToPromiseOptions = _ref$objectToPromiseO === undefined ? {} : _ref$objectToPromiseO;
  var _ref$optimistPromiseO = _ref.optimistPromiseOptions;
  var optimistPromiseOptions = _ref$optimistPromiseO === undefined ? [] : _ref$optimistPromiseO;
  var _ref$offlineQueueOpti = _ref.offlineQueueOptions;
  var offlineQueueOptions = _ref$offlineQueueOpti === undefined ? [] : _ref$offlineQueueOpti;
  var _ref$middlewares = _ref.middlewares;
  var middlewares = _ref$middlewares === undefined ? [] : _ref$middlewares;
  var _ref$reducers = _ref.reducers;
  var reducers = _ref$reducers === undefined ? {} : _ref$reducers;
  var feedbackOptions = _ref.feedbackOptions;

  var reducer = (0, _reduxOptimist2.default)((0, _redux.combineReducers)(_extends({
    offlineQueue: _reduxQueueOffline.reducer,
    routing: _reactRouterRedux.routerReducer,
    feedback: _reduxToastFeedback.reducer
  }, reducers)));

  var hashHistory = (0, _scrollBehavior2.default)((0, _reactRouter.useRouterHistory)(_createHashHistory2.default)({
    queryKey: false
  }));

  var _middlewares = [_reduxQueueOffline.middleware.apply(undefined, _toConsumableArray(offlineQueueOptions))];

  if (process.env.NODE_ENV !== 'production') {
    var createLogger = require('redux-logger');
    _middlewares.push(createLogger(loggerOptions));
  }

  var engine = void 0;
  if (storageMap) {
    engine = (0, _reduxStorageEngineLocalstorageMap2.default)(storageMap);
    engine = (0, _reduxStorageDecoratorDebounce2.default)(engine, storageDebounce);
    engine = (0, _reduxStorageDecoratorMigrate2.default)(engine, storageVersion);
    storageMigrations.forEach(function (migration, i) {
      engine.addMigration(i, migration);
    });

    var storageMiddleware = storage.createMiddleware(engine, blacklistedActions);
    _middlewares.push(storageMiddleware);
    reducer = storage.reducer(reducer);
  }

  _middlewares = _middlewares.concat(middlewares).concat([(0, _reduxToastFeedback.middleware)(feedbackOptions), (0, _reduxObjectToPromise2.default)(objectToPromiseOptions), _reduxOptimistPromise2.default.apply(undefined, _toConsumableArray(optimistPromiseOptions))]);

  var createStoreWithMiddleware = _redux.applyMiddleware.apply(undefined, _toConsumableArray(_middlewares))(_redux.createStore);

  var store = createStoreWithMiddleware(reducer);

  // Sync dispatched route actions to the history
  var history = (0, _reactRouterRedux.syncHistoryWithStore)(hashHistory, store);

  history.listen(function (location) {
    return location && sendAppView(location.pathname);
  });

  if (engine) {
    return storage.createLoader(engine)(store).then(function () {
      return {
        history: history,
        store: store
      };
    });
  }

  return {
    history: history,
    store: store
  };
};

module.exports.Provider = (0, _reduxQueueOfflineListener2.default)(_reactRedux.Provider);
module.exports.Toast = require('redux-toast-feedback/build/Toast');